Main Page | Namespace List | Class Hierarchy | Alphabetical List | Compound List | File List | Namespace Members | Compound Members | File Members

# WindowsPipeSink Class Reference

`#include <winpipes.h>`

Inheritance diagram for WindowsPipeSink:

List of all members.

## Detailed Description

Windows Pipe Sink.

Definition at line 123 of file winpipes.h.

## SIGNALS
virtual void | IsolatedInitialize (const NameValuePairs &parameters)
virtual bool | IsolatedMessageSeriesEnd (bool blocking)
virtual void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| initialize or reinitialize this object
virtual bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| flush buffered input and/or output
virtual bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| mark end of a series of messages
virtual void | SetAutoSignalPropagation (int propagation)
| set propagation of automatically generated and transfered signals
virtual int | GetAutoSignalPropagation () const
## ATTACHMENT
virtual bool | Attachable ()
| returns whether this object allows attachment
virtual BufferedTransformation * | AttachedTransformation ()
| returns the object immediately attached to this object or NULL for no attachment
virtual const BufferedTransformation * | AttachedTransformation () const
virtual void | Detach (BufferedTransformation *newAttachment=0)
| delete the current attachment chain and replace it with newAttachment
virtual void | Attach (BufferedTransformation *newAttachment)
| add newAttachment to the end of attachment chain
## Public Member Functions
| WindowsPipeSink (HANDLE h=INVALID_HANDLE_VALUE, unsigned int maxBufferSize=0, bool autoFlush=false)
bool | GetOwnership () const
void | SetOwnership (bool own)
| operator HANDLE ()
bool | HandleValid () const
void | AttachHandle (HANDLE h, bool own=false)
HANDLE | DetachHandle ()
void | CloseHandle ()
unsigned int | GetMaxWaitObjectCount () const
| maximum number of wait objects that this object can return
void | GetWaitObjects (WaitObjectContainer &container)
| put wait objects into container
unsigned int | Put2 (const byte *inString, unsigned int length, int messageEnd, bool blocking)
| input multiple bytes for blocking or non-blocking processing
unsigned int | TimedFlush (unsigned long maxTime, unsigned int targetSize=0)
| flush to device for no more than maxTime milliseconds
void | SetMaxBufferSize (unsigned int maxBufferSize)
void | SetAutoFlush (bool autoFlush=true)
unsigned int | GetMaxBufferSize () const
unsigned int | GetCurrentBufferSize () const
bool | IsolatedFlush (bool hardFlush, bool blocking)
BufferedTransformation & | Ref ()
| return a reference to this object
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
bool | Wait (unsigned long milliseconds)
| wait on this object
bool | MustWaitForResult ()
void | Send (const byte *buf, unsigned int bufLen)
unsigned int | GetSendResult ()
void | SendEof ()
unsigned int | GetMaxWaitObjectCount () const
| maximum number of wait objects that this object can return
void | GetWaitObjects (WaitObjectContainer &container)
| put wait objects into container
virtual bool | MustWaitToSend ()
bool | Wait (unsigned long milliseconds)
| wait on this object
SIGNALS
virtual void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| initialize or reinitialize this object
virtual bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| flush buffered input and/or output
virtual bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| mark end of a series of messages
SIGNALS
virtual void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| initialize or reinitialize this object
virtual bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| flush buffered input and/or output
virtual bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| mark end of a series of messages
SIGNALS
virtual void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| initialize or reinitialize this object
virtual bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| flush buffered input and/or output
virtual bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| mark end of a series of messages
SIGNALS
virtual void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| initialize or reinitialize this object
virtual bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| flush buffered input and/or output
virtual bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| mark end of a series of messages
SIGNALS
virtual void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| initialize or reinitialize this object
virtual bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| flush buffered input and/or output
virtual bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| mark end of a series of messages
SIGNALS
virtual void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| initialize or reinitialize this object
virtual bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| flush buffered input and/or output
virtual bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| mark end of a series of messages
SIGNALS
virtual void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| initialize or reinitialize this object
virtual bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| flush buffered input and/or output
virtual bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| mark end of a series of messages
SIGNALS
virtual void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| initialize or reinitialize this object
virtual bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| flush buffered input and/or output
virtual bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| mark end of a series of messages
SIGNALS
virtual void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| initialize or reinitialize this object
virtual bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| flush buffered input and/or output
virtual bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| mark end of a series of messages
## Static Public Attributes
const std::string | NULL_CHANNEL
## Protected Member Functions
virtual void | HandleChanged ()
const NetworkSender & | GetSender () const
unsigned int | TransferTo2 (BufferedTransformation &target, unsigned long &transferBytes, const std::string &channel=NULL_CHANNEL, bool blocking=true)
unsigned int | CopyRangeTo2 (BufferedTransformation &target, unsigned long &begin, unsigned long end=ULONG_MAX, const std::string &channel=NULL_CHANNEL, bool blocking=true) const
virtual void | HandleError (const char *operation) const
void | CheckAndHandleError (const char *operation, BOOL result) const
## Static Protected Member Functions
int | DecrementPropagation (int propagation)
## Protected Attributes
HANDLE | m_h
bool | m_own

## Member Function Documentation

unsigned int NetworkSink::Put2 | ( | const byte * | inString,
|  | unsigned int | length,
|  | int | messageEnd,
|  | bool | blocking
| ) | `[virtual, inherited]`

  | input multiple bytes for blocking or non-blocking processing Parameters:
  messageEnd | means how many filters to signal MessageEnd to, including this one
Implements BufferedTransformation. Definition at line 129 of file network.cpp. References ByteQueue::CurrentSize(), ByteQueue::FinalizeLazyPut(), INFINITE_TIME, ByteQueue::LazyPut(), NetworkSender::SendEof(), NetworkSink::TimedFlush(), and ByteQueue::UndoLazyPut().

unsigned int NetworkSink::TimedFlush | ( | unsigned long | maxTime,
|  | unsigned int | targetSize = 0
| ) | `[virtual, inherited]`

| flush to device for no more than maxTime milliseconds This function will repeatedly attempt to flush data to some device, until the queue is empty, or a total of maxTime milliseconds have elapsed. If maxTime == 0, at least one attempt will be made to flush some data, but it is likely that not all queued data will be flushed, even if the device is ready to receive more data without waiting. If you want to flush as much data as possible without waiting for the device, call this function in a loop. For example: while (sink.TimedFlush(0) > 0) {} Returns: number of bytes flushed Implements NonblockingSink. Definition at line 157 of file network.cpp. References ByteQueue::CurrentSize(), Timer::ElapsedTime(), NetworkSender::GetSendResult(), INFINITE_TIME, ByteQueue::IsEmpty(), NetworkSender::MustWaitForResult(), NetworkSender::MustWaitToSend(), NetworkSender::Send(), BufferedTransformation::Skip(), ByteQueue::Spy(), and Waitable::Wait(). Referenced by NetworkSink::Put2().

BufferedTransformation& BufferedTransformation::Ref | ( |  | ) | `[inline, inherited]`

| return a reference to this object This function is useful for passing a temporary BufferedTransformation object to a function that takes a non-const reference. Definition at line 702 of file cryptlib.h.

virtual byte* BufferedTransformation::CreatePutSpace | ( | unsigned int & | size | ) | `[inline, virtual, inherited]`

  | request space to write bytes into for processing Parameters:
  size | is requested size (as a hint) for input, and size of the returned space for output
Reimplemented in HashFilter, ArraySink, ArrayXorSink, and ByteQueue. Definition at line 720 of file cryptlib.h. Referenced by ArrayXorSink::CreatePutSpace().

virtual unsigned int BufferedTransformation::PutModifiable2 | ( | byte * | inString,
|  | unsigned int | length,
|  | int | messageEnd,
|  | bool | blocking
| ) | `[inline, virtual, inherited]`

  | input multiple bytes that may be modified by callee for blocking or non-blocking processing Parameters:
  messageEnd | means how many filters to signal MessageEnd to, including this one
Reimplemented in FilterWithBufferedInput. Definition at line 738 of file cryptlib.h.

bool BufferedTransformation::Flush | ( | bool | hardFlush,
|  | int | propagation = -1,
|  | bool | blocking = true
| ) | `[virtual, inherited]`

  | flush buffered input and/or output Parameters:
  hardFlush | is used to indicate whether all data should be flushed
Note: Hard flushes must be used with care. It means try to process and output everything, even if there may not be enough data to complete the action. For example, hard flushing a HexDecoder would cause an error if you do it after inputing an odd number of hex encoded characters. For some types of filters, for example ZlibDecompressor, hard flushes can only be done at "synchronization points". These synchronization points are positions in the data stream that are created by hard flushes on the corresponding reverse filters, in this example ZlibCompressor. This is useful when zlib compressed data is moved across a network in packets and compression state is preserved across packets, as in the ssh2 protocol. Reimplemented in Filter, Redirector, SecretSharing, and InformationDispersal. Definition at line 169 of file cryptlib.cpp. References BufferedTransformation::AttachedTransformation().

bool BufferedTransformation::MessageSeriesEnd | ( | int | propagation = -1,
|  | bool | blocking = true
| ) | `[virtual, inherited]`

| mark end of a series of messages There should be a MessageEnd immediately before MessageSeriesEnd. Reimplemented in Filter, and Redirector. Definition at line 175 of file cryptlib.cpp. References BufferedTransformation::AttachedTransformation().

virtual void BufferedTransformation::SetAutoSignalPropagation | ( | int | propagation | ) | `[inline, virtual, inherited]`

| set propagation of automatically generated and transfered signals propagation == 0 means do not automaticly generate signals Reimplemented in SourceTemplate< T >, SourceTemplate< FileStore >, SourceTemplate< RandomNumberStore >, and SourceTemplate< StringStore >. Definition at line 778 of file cryptlib.h.

unsigned long BufferedTransformation::MaxRetrievable | ( |  | ) | const`[virtual, inherited]`

| returns number of bytes that is currently ready for retrieval All retrieval functions return the actual number of bytes retrieved, which is the lesser of the request number and MaxRetrievable(). Reimplemented in FileStore, RandomNumberStore, NullStore, MessageQueue, ByteQueue, and RandomPool. Definition at line 229 of file cryptlib.cpp. References BufferedTransformation::AttachedTransformation(), and BufferedTransformation::CopyTo(). Referenced by RandomNumberStore::AnyRetrievable(), and Integer::BERDecode().

bool BufferedTransformation::GetNextMessage | ( |  | ) | `[virtual, inherited]`

| start retrieving the next message Returns false if no more messages exist or this message is not completely retrieved. Reimplemented in MessageQueue, and Store. Definition at line 318 of file cryptlib.cpp. References BufferedTransformation::AnyMessages(), and BufferedTransformation::AttachedTransformation().

virtual bool BufferedTransformation::Attachable | ( |  | ) | `[inline, virtual, inherited]`

| returns whether this object allows attachment Some BufferedTransformation objects (e.g. Filter objects) allow other BufferedTransformation objects to be attached. When this is done, the first object instead of buffering its output, sents that output to the attached object as input. The entire attachment chain is deleted when the anchor object is destructed. Reimplemented in Filter. Definition at line 926 of file cryptlib.h. Referenced by BufferedTransformation::Attach().

bool Waitable::Wait | ( | unsigned long | milliseconds | ) | `[inherited]`

| wait on this object same as creating an empty container, calling GetWaitObjects(), and calling Wait() on the container Definition at line 101 of file wait.cpp. References Waitable::GetWaitObjects(), and WaitObjectContainer::Wait(). Referenced by NetworkSource::GeneralPump2(), and NetworkSink::TimedFlush().

bool Waitable::Wait | ( | unsigned long | milliseconds | ) | `[inherited]`

| wait on this object same as creating an empty container, calling GetWaitObjects(), and calling Wait() on the container Definition at line 101 of file wait.cpp. References Waitable::GetWaitObjects(), and WaitObjectContainer::Wait(). Referenced by NetworkSource::GeneralPump2(), and NetworkSink::TimedFlush().

The documentation for this class was generated from the following file:

- winpipes.h